<!DOCTYPE html>
<html>
  <head>
    <title>Penguin Data set scatter Plot</title>
    <style>
      body{
        margin :0;
        overflow:hidden;
      }
      .tick text{
        font-size : 24px;
      }
    </style>
    <script src="https://unpkg.com/d3@5.11.0/dist/d3.min.js"></script>
  </head>
  <body>
    <script>
      const {csv,select,scaleLinear,extent,axisLeft,axisBottom} = d3;
  const csvUrl =
    'https://gist.githubusercontent.com/BHARGAVICHANDU1/2e9bb974df9f27f59084f544c26da15b/raw/d6664245d99e3310043697be75f881717eab0895/penguin_data.csv'
  const parseRow = (d) =>{
    d.bill_length_mm = +d.bill_length_mm;
    d.bill_depth_mm = +d.bill_depth_mm;
    d.flipper_length_mm = +d.flipper_length_mm;
    d.body_mass_g = +d.body_mass_g;
    return d;
  };
   const xValue = (d) => d.flipper_length_mm;
      const yValue = (d) => d.body_mass_g;
      const rxValue = (d) => d.bill_length_mm;
      const ryValue = (d) => d.bill_depth_mm;
      const speciesValue = (d) => d.species;
      const margin = {
        top :90,
        right : 30,
        bottom: 100,
        left:120,
      };
      const radius = 5;
      const width  = window.innerWidth;
      const height = window.innerHeight;
      const svg = select('body')
      				.append('svg')
              .attr('width',width)
              .attr('height',height);
			const main = async() =>{
      const data = await csv(csvUrl,parseRow);
      const x = scaleLinear()
              .domain(extent(data,xValue))
                .range([margin.left,width-				margin.right]);
    	const y = scaleLinear()
              .domain(extent(data,yValue))
            .range([height-margin.bottom,margin.top]);
                      
      const marker = (d) =>{
        switch(d){
          case 'Adelie' : return 'yellow';
          case 'Gentoo' : return 'green';
          default : return 'brown';
        }
      }
    const marks = data.map((d) =>({
      x : x(xValue(d)),
      y : y(yValue(d)),
      species : speciesValue(d),
      color : marker(speciesValue(d)),
      rx : rxValue(d),
      ry : ryValue(d),
    }));
    svg.selectAll('circle')
        .data(marks)
        .join('circle')
        .attr('cx',(d) =>d.x)
        .attr('cy',(d) =>d.y)
        .attr('fill',(d) =>d.color)
        .attr('rx',(d) =>(d.rx))
        .attr('ry',(d) =>(d.ry))
        .attr('r',radius);
                
    svg.append('g')
			.attr('transform',
      `translate(${margin.left},0)`)
			.call(axisLeft(y))
      .attr("font-family","cursive");